Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.digester
Class SetPropertiesRule

    java.lang.Object
      org.apache.commons.digester.Rule
          org.apache.commons.digester.SetPropertiesRule

    public class SetPropertiesRule

extends Rule

Rule implementation that sets properties on the object at the top of the stack, based on attributes with corresponding names.

This rule supports custom mapping of attribute names to property names. The default mapping for particular attributes can be overridden by using `SetPropertiesRule(String[] attributeNames, String[] propertyNames)`. This allows attributes to be mapped to properties with different names. Certain attributes can also be marked to be ignored.

Field Summary

Fields inherited from class org.apache.commons.digester.Rule
`digester, namespaceURI`

Constructor Summary
`SetPropertiesRule()` Base constructor.
`SetPropertiesRule(Digester digester)` Deprecated. The digester instance is now set in the `Digester.addRule(java.lang.String, org.apache.commons.digester.Rule)` method. Use `SetPropertiesRule()` instead.
`SetPropertiesRule(String[] attributeNames, String[] propertyNames)` Constructor allows attribute->property mapping to be overriden.
`SetPropertiesRule(String attributeName, String propertyName)` Convenience constructor overrides the mapping for just one property.

Method Summary
`void` | `addAlias(String attributeName, String propertyName)` Add an additional attribute name to property name mapping.
`void` | `begin(Attributes attributes)` Process the beginning of this element.
`boolean` | `isIgnoreMissingProperty()` Are attributes found in the xml without matching properties to be ignored?
`void` | `setIgnoreMissingProperty(boolean ignoreMissingProperty)` Sets whether attributes found in the xml without matching properties should be ignored.
`String` | `toString()` Render a printable version of this Rule.

Methods inherited from class org.apache.commons.digester.Rule
`begin, body, body, end, end, finish, getDigester, getNamespaceURI, setDigester, setNamespaceURI`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SetPropertiesRule

    public SetPropertiesRule(Digester digester)

  Deprecated. The digester instance is now set in the `Digester.addRule(java.lang.String, org.apache.commons.digester.Rule)` method. Use `SetPropertiesRule()` instead.

  Default constructor sets only the the associated Digester.

  Parameters:
    `digester` - The digester with which this rule is associated

### SetPropertiesRule

    public SetPropertiesRule()

  Base constructor.

### SetPropertiesRule

    public SetPropertiesRule(String attributeName,
                             String propertyName)

  Convenience constructor overrides the mapping for just one property.

  For details about how this works, see `SetPropertiesRule(String[] attributeNames, String[] propertyNames)`.

  Parameters:
    `attributeName` - map this attribute
    `propertyName` - to a property with this name

### SetPropertiesRule

    public SetPropertiesRule(String[] attributeNames,
                             String[] propertyNames)

  Constructor allows attribute->property mapping to be overriden.

  Two arrays are passed in. One contains the attribute names and the other the property names. The attribute name / property name pairs are match by position In order words, the first string in the attribute name list matches to the first string in the property name list and so on.

  If a property name is null or the attribute name has no matching property name, then this indicates that the attibute should be ignored.

  ##### Example One

  The following constructs a rule that maps the `alt-city` attribute to the `city` property and the `alt-state` to the `state` property. All other attributes are mapped as usual using exact name matching. ``

            SetPropertiesRule(
                      new String[] {"alt-city", "alt-state"},
                      new String[] {"city", "state"});

  ##### Example Two

  The following constructs a rule that maps the `class` attribute to the `className` property. The attribute `ignore-me` is not mapped. All other attributes are mapped as usual using exact name matching. ``

            SetPropertiesRule(
                      new String[] {"class", "ignore-me"},
                      new String[] {"className"});

  Parameters:
    `attributeNames` - names of attributes to map
    `propertyNames` - names of properties mapped to

Method Detail

### begin

    public void begin(Attributes attributes)
               throws Exception

  Process the beginning of this element.

  Overrides:
    `begin` in class `Rule`
  Parameters:
    `attributes` - The attribute list of this element
  Throws:
    `Exception`

### addAlias

    public void addAlias(String attributeName,
                         String propertyName)

  Add an additional attribute name to property name mapping. This is intended to be used from the xml rules.

### toString

    public String toString()

  Render a printable version of this Rule.

  Overrides:
    `toString` in class `Object`

### isIgnoreMissingProperty

    public boolean isIgnoreMissingProperty()

  Are attributes found in the xml without matching properties to be ignored?

  If false, the parsing will interrupt with an `NoSuchMethodException` if a property specified in the XML is not found. The default is true.

  Returns:
    true if skipping the unmatched attributes.

### setIgnoreMissingProperty

    public void setIgnoreMissingProperty(boolean ignoreMissingProperty)

  Sets whether attributes found in the xml without matching properties should be ignored. If set to false, the parsing will throw an `NoSuchMethodException` if an unmatched attribute is found. This allows to trap misspellings in the XML file.

  Parameters:
    `ignoreMissingProperty` - false to stop the parsing on unmatched attributes.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.